import { Injectable } from '@angular/core';
import { HttpClient } from '@angular/common/http';
import { Observable } from 'rxjs';

import { ApplicationConfigService } from 'app/core/config/application-config.service';

export class DeploymentInfo {
  branch = '';
  commitId = '';
  deploymentDate = '';
}
@Injectable({ providedIn: 'root' })
export class ApplicationInfoService {
  cachedDeploymentInfo: DeploymentInfo;
  inLoading = false;
  constructor(private http: HttpClient, private applicationConfigService: ApplicationConfigService) {
    this.cachedDeploymentInfo = {} as DeploymentInfo;
  }

  public loadOerLink(): Observable<string> {
    return this.http.get(this.applicationConfigService.getEndpointFor( 'api/applicationInfo/oerLinkInfo'), { responseType: 'text' });
  }

  public getDeploymentInfo(): DeploymentInfo {
    if (!this.cachedDeploymentInfo.branch && !this.inLoading) {
      this.inLoading = true;
      this.loadDeploymentInfo().subscribe(res => {
        this.cachedDeploymentInfo = res;
        this.inLoading = false;
      });
    }
    return this.cachedDeploymentInfo;
  }
  
    private loadDeploymentInfo(): Observable<DeploymentInfo> {
    return this.http.get<DeploymentInfo>(SERVER_API_URL + 'api/applicationInfo/deploymentInfo');
  }


}
