package at.ac.uibk.gitsearch.service.management;

import static org.hamcrest.CoreMatchers.anyOf;
import static org.hamcrest.CoreMatchers.is;

import org.hamcrest.MatcherAssert;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.actuate.health.Health;
import org.springframework.boot.actuate.health.HealthContributorRegistry;
import org.springframework.boot.actuate.health.HealthIndicator;
import org.springframework.boot.actuate.health.Status;
import org.springframework.boot.test.context.SpringBootTest;

import at.ac.uibk.gitsearch.GitsearchApp;
import at.ac.uibk.gitsearch.config.ApplicationProperties;

@SpringBootTest(classes = GitsearchApp.class)
public class PluginHealthCheckRegistryIT {

	
	@Autowired
	private ApplicationProperties applicationProperties;
	@Autowired
	private HealthContributorRegistry healthContributorRegistry;

	@Test
	public void testHealth() {
		healthContributorRegistry.forEach(
				contributor -> {
					if(applicationProperties.getRegisteredConnectors().stream().anyMatch(c -> c.getUrl().equals(contributor.getName()))) {
						Health h = ((HealthIndicator) contributor.getContributor()).health();
						MatcherAssert.assertThat("Health for " + contributor.getName() + " should be either be up or down, but was " + h.getStatus(), 
								h.getStatus(), anyOf(is(Status.UP), is(Status.DOWN)));
					}
				}
				);
	}
	
	
}
